﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using System.Threading;

using SuperMap.Realspace;
using SuperMap.Data;
using SuperMap.Desktop;

namespace SuperMap.Desktop.AerialSurvey
{
    class _CtrlActionSceneDev : CtrlAction
    {
        GeoModel3D geoModel = null;
        GeoRegion3D geoRegionHorizontal = null;
        GeoRegion3D geoRegionVertical = null;


        public System.Windows.Forms.Timer t = new System.Windows.Forms.Timer();

        //Stop timer

        static public bool tFly = false;

        public _CtrlActionSceneDev(IBaseItem caller)
            : base(caller)
        {
            t.Tick += new EventHandler(t_Tick);
            t.Interval = 100;
        }

        void t_Tick(object sender, EventArgs e)
        {
            #region  Aerial Survey
            IFormScene formScene = Application.ActiveForm as IFormScene;
            Point3D pnt = geoModel.Position;
            pnt.Y += 0.00015;
            geoModel.Position = pnt;

            geoRegionHorizontal[0][0] = new Point3D(pnt.X, pnt.Y, pnt.Z);
            geoRegionHorizontal[0][3] = new Point3D(pnt.X, pnt.Y, pnt.Z);

            pnt.Z = 0;
            pnt.X -= 0.1;
            geoRegionHorizontal[0][1] = new Point3D(pnt.X, pnt.Y, pnt.Z);
            geoRegionVertical[0][3] = new Point3D(pnt.X, pnt.Y, 3);

            pnt.X += 0.2;
            geoRegionHorizontal[0][2] = new Point3D(pnt.X, pnt.Y, pnt.Z);
            geoRegionVertical[0][2] = new Point3D(pnt.X, pnt.Y, 3);

            formScene.SceneControl.Scene.TrackingLayer.Clear();
            formScene.SceneControl.Scene.TrackingLayer.Add(geoRegionHorizontal, "asfjjfasd@341");
            formScene.SceneControl.Scene.TrackingLayer.Add(geoRegionVertical, "asfjjfasd@342");

            //Click Stop

            if (tFly ==  false)  
            {
                //Stop timer

                t.Enabled = !t.Enabled;

                //Empty horizontal and vertical measuring surfaces
                geoRegionHorizontal = null;
                geoRegionVertical = null;               

                //Empty tracking layer

                formScene.SceneControl.Scene.TrackingLayer.Clear();
            }
            #endregion

        }

        public override void Run()
        {
            try
            { 
                #region   Aerial Survey
                IFormScene formScene = Application.ActiveForm as IFormScene;
                geoModel = ((formScene.SceneControl.Scene.Layers[0].Features[0] as Feature3D).Geometry as GeoPlacemark).Geometry as GeoModel3D;

                if (geoRegionHorizontal == null)
                {
                    Point3D pnt = geoModel.Position;

                    geoRegionHorizontal = new GeoRegion3D();
                    geoRegionHorizontal.Style3D = new GeoStyle3D();
                    geoRegionHorizontal.Style3D.AltitudeMode = AltitudeMode.Absolute;
                    geoRegionHorizontal.Style3D.FillForeColor = Color.FromArgb(80, 0, 0, 255);
                    geoRegionHorizontal.Style3D.LineWidth = 2;

                    geoRegionHorizontal.Style3D.LineColor = Color.FromArgb(150, 255, 0, 0);

                    Point3Ds pnts = new Point3Ds();
                    pnts.Add(new Point3D(pnt.X, pnt.Y, pnt.Z));
                    pnts.Add(new Point3D(pnt.X - 0.005, pnt.Y, 0));
                    pnts.Add(new Point3D(pnt.X + 0.005, pnt.Y, 0));
                    pnts.Add(new Point3D(pnt.X, pnt.Y, pnt.Z));
                    geoRegionHorizontal.AddPart(pnts);

                    geoRegionVertical = new GeoRegion3D();
                    geoRegionVertical.Style3D = new GeoStyle3D();
                    geoRegionVertical.Style3D.AltitudeMode = AltitudeMode.Absolute;
                    geoRegionVertical.Style3D.FillForeColor = Color.FromArgb(80, 200, 0, 0);
                    geoRegionVertical.Style3D.LineWidth = 2;
                    geoRegionVertical.Style3D.LineColor = Color.FromArgb(150, 255, 0, 0);

                    pnts = new Point3Ds();
                    pnts.Add(new Point3D(pnt.X - 0.005, pnt.Y, 3));
                    pnts.Add(new Point3D(pnt.X + 0.005, pnt.Y, 3));
                    pnts.Add(new Point3D(pnt.X + 0.005, pnt.Y, 3));
                    pnts.Add(new Point3D(pnt.X - 0.005, pnt.Y, 3));
                    pnts.Add(new Point3D(pnt.X - 0.005, pnt.Y, 3));
                    geoRegionVertical.AddPart(pnts);

                    //Set target
                    GeoPoint3D GeoP = new GeoPoint3D(); 
                    GeoP.X = pnt.X;
                    GeoP.Y = pnt.Y;
                    GeoP.Z = pnt.Z * 10;
                    Camera camera = new Camera(pnt.X, pnt.Y, pnt.Z * 10);
                   // formScene.SceneControl.Scene.Fly(GeoP, FlyingMode.FlyingTo);
                    //formScene.SceneControl.Scene.Fly(camera, false);
                    formScene.SceneControl.Scene.Fly(camera, 1000);
                }
                t.Enabled = !t.Enabled;
                tFly = true;
                #endregion
            }
            catch (Exception)
            {
                if (geoModel == null)
                {
                    SuperMap.Desktop.Application.ActiveApplication.Output.Output("Please add model data!");
                }
                SuperMap.Desktop.Application.ActiveApplication.Output.Output("Error");
            }
        }
    }
}

